/*
 * Updated 2005/11/27
 * 
 * Mail : info@graviness.com
 * Home : http://www.graviness.com/
 */



/**
 * ^Aj[VNXilς݁jD
 * {@link AbstractEasingAnimation}NX̃TuNXłD
 * 
 *  {
 * p(t) = p_0 + (p_1 - p_0) * t
 * 
 * p_0	: JnʒuxNg
 * p_1	: ~ʒuxNg
 */
function class__LinearAnimation__extends__AbstractEasingAnimation__(window) {
	var className = Object.getClassName(arguments.callee);

	/**
	 * Constructor()
	 */
	var F = window[className] = function() {
		this.__super__(); // super();

		this.element = null;

		this.setStartPosition(0.0, 0.0);
		this.setEndPosition(0.0, 0.0);
	};

	var FP = Object.getPrototype(arguments.callee, window);

	/**
	 * ړΏۂݒD
	 * void f(JElement targetElement)
	 */
	FP.setElement = function(element) {
		this.element = element;
	}

	/**
	 * ړΏۂ擾D
	 * JElement f()
	 */
	FP.getElement = function() {
		return this.element;
	};

	/**
	 * JnʒuݒD
	 * void f(number x0, number y0)
	 * void f(Point p0)
	 */
	FP.setStartPosition = function() {
		var a = arguments;
		switch (a.length) {
			case 1 :
				this.x0 = a[0].x;
				this.y0 = a[0].y;
				return;
			case 2 :
				this.x0 = a[0];
				this.y0 = a[1];
				return;
			default :
				return void(window.errorMessage("IllegalArgumentsException@"
					+ className + "#setStartPosition(...)"));
		}
	};

	/**
	 * ~ʒuݒD
	 * void f(number x1, number y1)
	 * void f(Point p1)
	 */
	FP.setEndPosition = function() {
		var a = arguments;
		switch (a.length) {
			case 1 :
				this.x1 = a.x;
				this.y1 = a.y;
				return;
			case 2 :
				this.x1 = a[0];
				this.y1 = a[1];
				return;
			default :
				return void(window.errorMessage("IllegalArgumentsException@"
					+ className + "#setEndPosition(...)"));
		}
	};

	FP.init = function() {
	};

	FP.emove = function(currentFrame, endFrame, t, s) {
		this.element.setPosition(
			this.x0 + (this.x1 - this.x0) * s,
			this.y0 + (this.y1 - this.y0) * s);

		return true;
	};

	FP.destroy = function() {
	};
} class__LinearAnimation__extends__AbstractEasingAnimation__(window);
